// =====================================================================================
// Copyright  2005 by Shahed Khan. All rights are reserved.
// 
// If you like this code then feel free to go ahead and use it.
// The only thing I ask is that you don't remove or alter my copyright notice.
//
// Your use of this software is entirely at your own risk. I make no claims or
// warrantees about the reliability or fitness of this code for any particular purpose.
// If you make changes or additions to this code please mark your code as being yours.
// 
// website , email shahed.khan@gmail.com
// =====================================================================================


using System;

using Microsoft.Practices.EnterpriseLibrary.Logging;
//using Microsoft.Practices.EnterpriseLibrary.Configuration;
using Microsoft.Practices.EnterpriseLibrary.Caching;


namespace SmartMassEmail
{

	/// <summary>
	/// Helper class for dealing with enterprise library
	/// </summary>
	public class EntLibHelper 
	{
		#region Configuration Section Names

		private const string CONFIGURATION_SECTION_NAME = "globalConfiguration";
		
		private const string GENERAL_CACHE_MANAGER = "General Cache";
		private const string CACHING_STORE_PROVIDER = "Caching Store Provider";

		#endregion

		#region Logging

        //private const string INFO_CATEGORY = "Info";
        //private const string WARN_CATEGORY = "Warn";
        //private const string ERROR_CATEGORY = "Error";
        //private const string DEBUG_CATEGORY = "Debug";

        //private const string JOB_INFO_CATEGORY = "JobInfo";		
        //private const string JOB_ERROR_CATEGORY = "JobError";		

        //private const int INFO_PRIORITY = 4;
        //private const int INFO_EVENTID = 0;

        //private const int ERROR_PRIORITY = 3;
        //private const int ERROR_EVENTID = 0;

        //private const int WARN_PRIORITY = 2;
        //private const int WARN_EVENTID = 0;

        //private const int DEBUG_PRIORITY = 1;
        //private const int DEBUG_EVENTID = 0;

		/*
		Category - used to determine the routing of the LogEntry; 
		Priority - used to filter Log Entries, only those above the Minimum Priority are processed (defaults to -1 which indicates that the Minimum Priority should be used); 
		EventId - a value you can use to further categorise Log Entries (defaults to 0 for a LogEntry and to 1 for a LogEntry implicitly created by Logger.Write); 
		Severity - indicates the severity of the Log Entry, e.g., Information, Warning, Error etc. 
		Title - a summary of the LogEntry.Message. 
		*/
		
        private static CacheManager manager = CacheFactory.GetCacheManager(GENERAL_CACHE_MANAGER);

        //public static void Info( string title, object message )
        //{
        //    Logger.Write( "Log message", "Debug" );
        //    Logger.Write( message, INFO_CATEGORY, INFO_PRIORITY, INFO_EVENTID, Microsoft.Practices.EnterpriseLibrary.Logging.Severity.Information, title );
        //}

        //public static void Error( string title, object message )
        //{
        //    Logger.Write( message, ERROR_CATEGORY, ERROR_PRIORITY, ERROR_EVENTID, Microsoft.Practices.EnterpriseLibrary.Logging.Severity.Error, title );
        //}
		
        //public static void Warn( string title, object message )
        //{
        //    Logger.Write( message, WARN_CATEGORY, WARN_PRIORITY, WARN_EVENTID, Microsoft.Practices.EnterpriseLibrary.Logging.Severity.Warning, title );
        //}
		
        //public static void Debug( string title, object message )
        //{
        //    Logger.Write( message, DEBUG_CATEGORY, DEBUG_PRIORITY, DEBUG_EVENTID, Microsoft.Practices.EnterpriseLibrary.Logging.Severity.Unspecified, title );
        //}

        //public static void JobInfo( string title, Job job)
        //{
        //    string jobData = string.Format("Job: {0}{1}",job.ToString(),Environment.NewLine);
        //    foreach(JobDetail detail in job.JobDetailCollection)
        //    {
        //        jobData = string.Format("{0}{1}{2}",jobData,detail.ToString(),Environment.NewLine);
        //    }														
			

        //    Logger.Write( jobData, JOB_INFO_CATEGORY, INFO_PRIORITY, INFO_EVENTID, Microsoft.Practices.EnterpriseLibrary.Logging.Severity.Information, title );
        //}

        //public static void JobError( string title, Job job )
        //{
        //    string jobData = string.Format("Job: {0}{1}",job.ToString(),Environment.NewLine);
        //    foreach(JobDetail detail in job.JobDetailCollection)
        //    {
        //        jobData = string.Format("{0}{1}{2}",jobData,detail.ToString(),Environment.NewLine);
        //    }					

        //    Logger.Write( jobData, JOB_ERROR_CATEGORY, ERROR_PRIORITY, ERROR_EVENTID, Microsoft.Practices.EnterpriseLibrary.Logging.Severity.Error, title );
        //}
		
		#endregion

		#region Exception Handling


		

        //public static bool JobException( string title, Job job, Exception x )
        //{
        //    string jobData = string.Format("Job: {0}{1}",job.ToString(),Environment.NewLine);
        //    foreach(JobDetail detail in job.JobDetailCollection)
        //    {
        //        jobData = string.Format("{0}{1}{2}",jobData,detail.ToString(),Environment.NewLine);
        //    }														
        //    title = string.Format("{0}{1}{2}",title,jobData,Environment.NewLine);
        //    ApplicationException wrapped = new ApplicationException( title, x );
        //    bool rethrow = ExceptionPolicy.HandleException( wrapped, EXCEPTION_POLICY_NAME );
        //    return rethrow;
        //}		

		#endregion

		#region Caching

		public static void StoreInCache( string key, object data )
		{
			if( null == data ) manager.Remove( key );
			else manager.Add( key, data );			
		}

		public static object GetCachedObject( string key )
		{
			if( manager.Contains( key ) )
				return manager.GetData( key );
			else 
				return null;			
		}
		#endregion

	}
}
