
// =====================================================================================
// Copyright  2005 by Shahed Khan. All rights are reserved.
// 
// If you like this code then feel free to go ahead and use it.
// The only thing I ask is that you don't remove or alter my copyright notice.
//
// Your use of this software is entirely at your own risk. I make no claims or
// warrantees about the reliability or fitness of this code for any particular purpose.
// If you make changes or additions to this code please mark your code as being yours.
// 
// website , email shahed.khan@gmail.com
// =====================================================================================

using System;
using System.Collections.Specialized;
using System.Collections.Generic;
using System.Text;
using SmartTemplateEngine.Providers;
using System.Configuration;
using SmartTemplateEngine.Entities;

namespace SmartTemplateEngine.ImplementedProviders
{
    public class CodeDomGenerateOutputProvider: GenerateOutputProvider
    {
        public CodeDomGenerateOutputProvider( ) 
		{
		}

		#region GenerateOutput specific functions
        public override Template Generate(Template template)
		{
            try
            {
                template.IsSuccessful = true;
                LanguageType language = LanguageType.CSharp;
                string entry = "Render";
                string code = template.GeneratedCode.Trim();
                if (code == "") 
                    return template;
                
                //if (entry == "") entry = "Main";

                CompileEngine engine = new CompileEngine(code, language, entry);
                engine.References = template.Setting.References;
                engine.Run();
                template.Output = engine.OutputText;
                if (engine.errMsg.Length>0)
                {
                    template.IsSuccessful = false;
                    template.Error = engine.errMsg.ToString();
                    
                }
                
                
            }
            catch (Exception x)
            {
                template.InnerException = x;
                template.Error = x.ToString();
                template.IsSuccessful = false;
            }
            return template;
		}

		
		#endregion

		#region Provider specific behaviors
		public override void Initialize(string name, NameValueCollection configValue) {

		}

		public override string Name {
			get {
				return null;
			}
		}
		#endregion
    }
}
