/* Some codes are borrowed from this article Dynamically executing code in .Net by Rick Strahl
 *  http://www.west-wind.com/presentations/dynamicCode/DynamicCode.htm
 * 
 * I modified according to my need.
 * */


using System;
using System.Text.RegularExpressions;
using System.IO;
using System.Text;
using System.Configuration;
namespace SmartTemplateEngine.ImplementedProviders
{
	/// <summary>
	/// Summary description for ParseManager.
	/// </summary>
	public class ParseManager
	{
		public ParseManager()
		{
			//
			// TODO: Add constructor logic here
			//
		}

		public ParseManager( string code, string references )
		{
			this.code = code + "<%%>";
            this.references = references;
		}
		private string code;
        private string references;

		public string GetParsedResult()
		{
			string modifiedcode = GetCodeWithoutAssemblyNameSpacePropertyAndOther();
			
            string finalcode = references +
@"
namespace SmartTemplateEngine.ImplementedProviders
{
	/// <summary>
	/// Summary description for ParseManager.
	/// </summary>
	public class Parser
	{
		public Parser()
		{
			//
			// TODO: Add constructor logic here
			//
		}
		public static void Main()
		{			
		}
		public static string Render()
		{
			MemoryStream mStream = new MemoryStream();
			StreamWriter writer = new StreamWriter(mStream,System.Text.Encoding.UTF8);
			
			#:::#RenderMethod#:::#
//
            StreamReader sr = new StreamReader(mStream); 
			writer.Flush();
			mStream.Position = 0; 
			string returndata = sr.ReadToEnd();	
			return returndata;
		}
	}
}";
			finalcode = Regex.Replace(finalcode,"#:::#RenderMethod#:::#",modifiedcode);

			return finalcode;

		}
		

		private string GetCodeWithoutAssemblyNameSpacePropertyAndOther()
		{
			string tempcode = code;			
			//Modify this part if you want to read the <%@ tags also you can implement your own tags here.
            tempcode = Regex.Replace(tempcode,"(?i)<%@\\s*Property.*?%>",string.Empty);
			tempcode = Regex.Replace(tempcode,"(?i)<%@\\s*Assembly.*?%>",string.Empty);
			tempcode = Regex.Replace(tempcode,"(?i)<%@\\s*Import.*?%>",string.Empty);
			tempcode = Regex.Replace(tempcode,"(?i)<%@\\s*CodeTemplate.*?%>",string.Empty);
			
            //For the demo I am only dealing with the <%= and <% tags
            tempcode = ParseScript(tempcode);
			tempcode = Regex.Replace(tempcode,@"<%=.*?%>",new MatchEvaluator(this.RefineCalls),RegexOptions.Singleline);
			tempcode = Regex.Replace(tempcode,@"<%%>",string.Empty,RegexOptions.Singleline);
			tempcode = Regex.Replace(tempcode,@"<%[^=|@].*?%>",new MatchEvaluator(this.RefineCodeTag),RegexOptions.Singleline);		

			
			return tempcode;
		}

		string RefineCalls(Match m) 
		{
			// Get the matched string.
			string x = m.ToString();
			// If the first char is lower case...
			x= Regex.Replace(x,"<%=","\t\t\twriter.Write(");
			x=Regex.Replace(x,"%>",");");
			
			return x;
		}

		string RefineCodeTag(Match m) 
		{
			// Get the matched string.
			string x = m.ToString();
			// If the first char is lower case...
			x= x.Substring(2,x.Length-4);
			x="\t\t\t"+x;
			
			
			return x;
		}

		public string ParseScript(string lcCode)
		{
			if (lcCode == null)
				return "";
			MemoryStream mStream = new MemoryStream();
			StreamWriter writer = new StreamWriter(mStream,System.Text.Encoding.UTF8);

			int lnLast = 0;
			int lnAt2 = 0;
			int lnAt = lcCode.IndexOf("<%",0);
			if (lnAt == -1)
				return lcCode;
			
			while (lnAt > -1) 
			{
				if (lnAt > -1)    			 	
					// *** Catch the plain text write out to the Response Stream as is - fix up for quotes
					writer.Write("\t\t\twriter.Write(@\"" + lcCode.Substring(lnLast,lnAt - lnLast).Replace("\"","\"\"") + "\" );\r\n\r\n");
				
				//*** Find end tag
				lnAt2 = lcCode.IndexOf("%>",lnAt);
				if (lnAt2 < 0)
					break;

				writer.Write(lcCode.Substring(lnAt,lnAt2-lnAt + 2));

				lnLast = lnAt2 + 2;
				lnAt = lcCode.IndexOf("<%",lnLast);
				if (lnAt < 0)
					// *** Write out the final block of non-code text
					writer.Write("\t\t\twriter.Write(@\"" + lcCode.Substring(lnLast,lcCode.Length - lnLast).Replace("\"","\"\"") + "\" );\r\n\r\n");				
			}
			
			writer.Flush();

			mStream.Position = 0; 
  
			StreamReader sr = new StreamReader(mStream); 

			string returndata = sr.ReadToEnd();	
			return returndata;
		}

	}
}
