
// =====================================================================================
// Copyright  2005 by Shahed Khan. All rights are reserved.
// 
// If you like this code then feel free to go ahead and use it.
// The only thing I ask is that you don't remove or alter my copyright notice.
//
// Your use of this software is entirely at your own risk. I make no claims or
// warrantees about the reliability or fitness of this code for any particular purpose.
// If you make changes or additions to this code please mark your code as being yours.
// 
// website , email shahed.khan@gmail.com
// =====================================================================================

using System;
using System.Collections.Generic;
using System.Text;

namespace SmartTemplateEngine.Util
{
    public class DataSchemaHelper
    {
        #region ColumnSchema
        public string GetCSType(ColumnSchema cschema)
        {
            return cschema.DataType.ToString();
        }
        public string GetCSDefaultByType(ColumnSchema cschema)
        {
            if (cschema.DataType == typeof(System.String))
                return "String.Empty";
            if (cschema.DataType == typeof(System.Int16))
                return "0";
            if (cschema.DataType == typeof(System.Int32))
                return "0";
            if (cschema.DataType == typeof(System.Int64))
                return "0";
            if (cschema.DataType == typeof(System.Decimal))
                return "0";
            if (cschema.DataType == typeof(System.Boolean))
                return "false";
            if (cschema.DataType == typeof(System.DateTime))
                return "Datetime.Now";    
            return "null";
        }
        public string GetPropertyName(ColumnSchema cschema)
        {
            //Check for AliasName and return ColumnName or the AliasName
            return cschema.ColumnName;
        }
        public string GetNativeType(ColumnSchema cschema)
        {
            return "return NativeType Here";
        }
        #endregion

        #region TableSchema
        public string GetClassName(TableSchema tschema)
        {
            //Check for AliasName and return TableName or the AliasName
            return tschema.TableName;
        }

        public string GetAbstractClassName(TableSchema tschema)
        {
            return String.Format("{0}Base",tschema.TableName);
        }
        #endregion

    }
}
