using System;
using System.Collections.Generic;
using System.Text;
using SmartTemplateEngine.Entities;
using SmartTemplateEngine.Providers;
using System.Xml;
using System.Xml.Serialization;
using System.IO;
using System.Windows.Forms;

namespace SmartTemplateEngine.WindowsApplication
{
    public class OpenTemplateCommand: ICommand
    {
        public OpenTemplateCommand(string path)
        {
            _path = path;
        }

        private string _path=string.Empty;
        private Template _template = null;
        public Template Template
        {
            get 
            {
                return _template;
            }
        }
        
        public void Execute( )
        {
            try
            {
                _template = new Template();
                _template = (Template)LoadFromXml(_template, _path);
                
                //Decode Input
                _template.Input = DecodeBase64(_template.Input);                
                _template.Setting.Using_Libraries = DecodeBase64(_template.Setting.Using_Libraries);
            }
            catch (Exception x)
            {
                _template = null;
                MessageBox.Show(x.ToString());

            }
           
        }

        public static string DecodeBase64(string AString)
        {
            byte[] data;
            if (AString == null)
                return string.Empty;
            if (0 == AString.Length)
                return string.Empty;
            // Get the byte data
            data = Convert.FromBase64String(AString);
            try
            {
                return System.Text.ASCIIEncoding.UTF8.GetString(data);
            }
            catch
            {
                return string.Empty;
            }

        }

        private Object LoadFromXml(Object objectToLoad, string path)
        {
            TextReader textReader = null;

            try
            {
                Type thetype = objectToLoad.GetType();
                XmlSerializer x = new XmlSerializer(thetype);
                textReader = new StreamReader(path);
                objectToLoad = x.Deserialize(textReader);
            }
            finally
            {
                //Make sure to close the file even if an exception is raised...
                if (textReader != null)
                    textReader.Close();
            }

            return objectToLoad;
        }
    }
}
