using System;
using System.Collections.Generic;
using System.Text;
using SmartTemplateEngine.Entities;
using SmartTemplateEngine.Providers;

namespace SmartTemplateEngine.WindowsApplication
{
    public class ParseTemplateCommand: ICommand
    {
        public ParseTemplateCommand(Template template)
        {
            _Template = template;
        }

        private Template _Template;

        public Template Template
        {
            get { return _Template; }         
        }

        private string _GeneratedCode = string.Empty;
        public string GeneratedCode
        {
            get { return _GeneratedCode; }
        }

        private string _Output = string.Empty;
        public string Output
        {
            get { return _Output; }
        }


        public void Execute( )
        {
                
            ParseTemplate.Parse(_Template);
            _GeneratedCode = _Template.GeneratedCode;           
            
            GenerateOutput.Generate(_Template);
            _Output = Template.Output;
            
        }
    }
}
