using System;
using System.Collections.Generic;
using System.Text;
using SmartTemplateEngine.Entities;
using SmartTemplateEngine.Providers;
using System.Xml;
using System.Xml.Serialization;
using System.IO;
using System.Windows.Forms;

namespace SmartTemplateEngine.WindowsApplication
{
    public class SaveTemplateCommand: ICommand
    {
        public SaveTemplateCommand(string path, Template template)
        {
            _path = path;
            _template = template;
        }

        private string _path=string.Empty;
        private Template _template = null;

        
        public void Execute( )
        {
            //Encode to Base64
            _template.Input = EncodeBase64(_template.Input);
            _template.Setting.Using_Libraries = EncodeBase64(_template.Setting.Using_Libraries);
            
            if (File.Exists(_path))
            {
                File.Delete(_path);
            }
            //
            FileStream fs = new FileStream(_path, FileMode.OpenOrCreate, FileAccess.Write);
            try
            {
                System.Xml.Serialization.XmlSerializer x = new System.Xml.Serialization.XmlSerializer(_template.GetType());
                x.Serialize(fs, _template);
                fs.Close();
            }
            catch (Exception x)
            {
                MessageBox.Show(x.ToString());
            }
            
        }

        public static string EncodeBase64(string AString)
        {
            if (AString == null)
                return string.Empty;
            if (AString == string.Empty)
            {
                return AString;
            }
            else
            {

                try
                {
                    //ASCIIEncoding ascii = new ASCIIEncoding();
                    UTF8Encoding uft = new UTF8Encoding();
                    byte[] data = uft.GetBytes(AString);
                    //Convert to String
                    return Convert.ToBase64String(data);
                }
                catch { return string.Empty; }


            }
        }
    }
}
